﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.DataVisualization;
using System.Threading.Tasks;
using System.Threading;

namespace WindowsFormsApplication6
{
    public partial class Form1 : Form
    {
        DataTable lineTable;
        CancellationTokenSource tokenSource;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
            lineTable = CreateLineTable();
            CategoryXAxis xAxis = new CategoryXAxis();
            NumericYAxis yAxis = new NumericYAxis();

            yAxis.MinimumValue = 0;
            yAxis.MaximumValue = 100;
            xAxis.DataSource = lineTable;
            xAxis.Label = "Labels";
            xAxis.TitlePosition = AxisTitlePosition.Bottom;

            ultraDataChart1.Axes.Add(xAxis);
            ultraDataChart1.Axes.Add(yAxis);

            LineSeries lineSeries = new LineSeries();
            lineSeries.DataSource = lineTable;
            lineSeries.XAxis = xAxis;
            lineSeries.YAxis = yAxis;
            lineSeries.ValueMemberPath = "Values";

            ultraDataChart1.Series.Add(lineSeries);
            lineSeries.MarkerType = MarkerType.Circle;
            lineSeries.MarkerBrush = new SolidColorBrush(Color.Red);
        }

        private void AddPoints(CancellationToken ct)
        {
            Random r = new Random();

            while (true)
            {
                //update the data source itself from the UI Thread!!!
                ultraDataChart1.Invoke((MethodInvoker)delegate
                {
                    lineTable.Rows.RemoveAt(0);
                    lineTable.Rows.Add(new object[] { DateTime.Now.ToString("mm : ss"), r.Next() % 100 });
                });
                Thread.Sleep(100);

                if (ct.IsCancellationRequested)
                    break;
            }
        }



        private DataTable CreateLineTable()
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("Labels", typeof(string));
            dt.Columns.Add("Values", typeof(int));

            Random r = new Random();

            for (int i = 0; i < 25; i++)
            {
                dt.Rows.Add(new object[] { DateTime.Now.ToString("mm : ss"), r.Next() % 100 });
            }

            return dt;
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            tokenSource = new CancellationTokenSource();
            var ct = tokenSource.Token;

            var t = Task.Factory.StartNew(() => { AddPoints(ct); }, ct,
                TaskCreationOptions.LongRunning, TaskScheduler.Default);

            ultraButton1.Enabled = false;
            ultraButton2.Enabled = true;
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {
            ultraButton2.Enabled = false;
            ultraButton1.Enabled = true;

            tokenSource.Cancel();
        }



    }
}
